package org.joda.time;

import org.joda.time.chrono.BuddhistChronology;
import org.joda.time.chrono.ISOChronology;

import junit.framework.TestCase;

public class TestDateTime_Basics7 extends TestCase {

	long y2002days = 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365
			+ 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365;

	// 2002-04-05
	private long TEST_TIME1 = (y2002days + 31L + 28L + 31L + 5L - 1L) * DateTimeConstants.MILLIS_PER_DAY
			+ 12L * DateTimeConstants.MILLIS_PER_HOUR + 24L * DateTimeConstants.MILLIS_PER_MINUTE;

	private static final DateTimeZone PARIS = DateTimeZone.forID("Europe/Paris");

	private static final ISOChronology ISO_PARIS = ISOChronology.getInstance(PARIS);
	private static final BuddhistChronology BUDDHIST_UTC = BuddhistChronology.getInstanceUTC();

	public void test1() {
		DateTime test = new DateTime(TEST_TIME1 - 12345L, BUDDHIST_UTC);
		test.withTime(12, 24, 0, 0);
	}

	public void test2() {
		DateTime test = new DateTime(TEST_TIME1);
		test.withTime(25, 1, 1, 1);
	}

	public void test3() {
		DateTime test = new DateTime(2010, 3, 28, 0, 0, 0, 0, ISO_PARIS);
		test.withTime(2, 55, 0, 0);
	}
	
	public void test1b() {
		DateTime test = new DateTime(TEST_TIME1 - 12345L, BUDDHIST_UTC);
		test.withTime(17, 24, 0, 0);
	}
	
	public void test1c() {
		DateTime test = new DateTime(TEST_TIME1 - 12345L, BUDDHIST_UTC);
		test.withTime(16, 24, 0, 0);
	}
	
	public void test1d() {
		DateTime test = new DateTime(TEST_TIME1 - 12345L, BUDDHIST_UTC);
		test.withTime(18, 24, 0, 0);
	}
	
	public void test1e() {
		DateTime test = new DateTime(TEST_TIME1 - 12345L, BUDDHIST_UTC);
		test.withTime(20, 24, 0, 0);
	}
	
	public void test1f() {
		DateTime test = new DateTime(TEST_TIME1 - 12345L, BUDDHIST_UTC);
		test.withTime(21, 24, 0, 0);
	}
	
	public void test1g() {
		DateTime test = new DateTime(TEST_TIME1 - 12345L, BUDDHIST_UTC);
		test.withTime(22, 24, 0, 0);
	}
	
	public void test1h() {
		DateTime test = new DateTime(TEST_TIME1 - 12345L, BUDDHIST_UTC);
		test.withTime(23, 24, 0, 0);
	}
	
	public void test3b() {
		DateTime test = new DateTime(2010, 3, 28, 0, 0, 0, 0, ISO_PARIS);
		test.withTime(17, 55, 0, 0);
	}
	
	public void test3c() {
		DateTime test = new DateTime(2010, 3, 28, 0, 0, 0, 0, ISO_PARIS);
		test.withTime(16, 55, 0, 0);
	}
	
	public void test3d() {
		DateTime test = new DateTime(2010, 3, 28, 0, 0, 0, 0, ISO_PARIS);
		test.withTime(18, 55, 0, 0);
	}
	
	public void test3e() {
		DateTime test = new DateTime(2010, 3, 28, 0, 0, 0, 0, ISO_PARIS);
		test.withTime(20, 55, 0, 0);
	}
	
	public void test3f() {
		DateTime test = new DateTime(2010, 3, 28, 0, 0, 0, 0, ISO_PARIS);
		test.withTime(21, 55, 0, 0);
	}
	
	public void test3g() {
		DateTime test = new DateTime(2010, 3, 28, 0, 0, 0, 0, ISO_PARIS);
		test.withTime(22, 55, 0, 0);
	}
	
	public void test3h() {
		DateTime test = new DateTime(2010, 3, 28, 0, 0, 0, 0, ISO_PARIS);
		test.withTime(23, 55, 0, 0);
	}
	
	public static void main(String[] args) {
		TestDateTime_Basics7 t = new TestDateTime_Basics7();
		t.test1();
		t.test3();
		
		t.test1b();
		t.test1c();
		t.test1d();
		t.test1e();
		t.test1f();
		t.test1g();
		t.test1h();
		
		t.test3b();
		t.test3c();
		t.test3d();
		t.test3e();
		t.test3f();
		t.test3g();
		t.test3h();
	}

}
