package org.joda.time;

import org.joda.time.chrono.CopticChronology;

import junit.framework.TestCase;

public class TestInterval_Basics3 extends TestCase {

	private static final DateTimeZone PARIS = DateTimeZone.forID("Europe/Paris");
	private static final Chronology COPTIC_PARIS = CopticChronology.getInstance(PARIS);

	long y2002days = 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365
			+ 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365;
	long y2003days = 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365
			+ 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365;

	// 2002-06-09
	private long TEST_TIME_NOW = (y2002days + 31L + 28L + 31L + 30L + 31L + 9L - 1L) * DateTimeConstants.MILLIS_PER_DAY;

	// 2002-04-05
	private long TEST_TIME1 = (y2002days + 31L + 28L + 31L + 5L - 1L) * DateTimeConstants.MILLIS_PER_DAY
			+ 12L * DateTimeConstants.MILLIS_PER_HOUR + 24L * DateTimeConstants.MILLIS_PER_MINUTE;

	// 2003-05-06
	private long TEST_TIME2 = (y2003days + 31L + 28L + 31L + 30L + 6L - 1L) * DateTimeConstants.MILLIS_PER_DAY
			+ 14L * DateTimeConstants.MILLIS_PER_HOUR + 28L * DateTimeConstants.MILLIS_PER_MINUTE;

	public void testWithEndMillis_long1() {
		Interval base = new Interval(TEST_TIME1, TEST_TIME2, COPTIC_PARIS);
		Interval test = base.withEndMillis(TEST_TIME2 - 1);
	}

	public void testWithEndMillis_long2() {
		Interval test = new Interval(TEST_TIME1, TEST_TIME2);
		test.withEndMillis(TEST_TIME1 - 1);
	}

	public void testWithEndMillis_long3() {
		Interval base = new Interval(TEST_TIME1, TEST_TIME2, COPTIC_PARIS);
		Interval test = base.withEndMillis(TEST_TIME2);
	}
	
	public void testWithEndMillis_long1b() {
		Interval base = new Interval(TEST_TIME1, TEST_TIME2, COPTIC_PARIS);
		Interval test = base.withEndMillis(TEST_TIME1);
	}
	
	public void testWithEndMillis_long1c() {
		Interval base = new Interval(1, TEST_TIME2, COPTIC_PARIS);
		Interval test = base.withEndMillis(1);
	}
	
	public void testWithEndMillis_long1d() {
		Interval base = new Interval(-1, TEST_TIME2, COPTIC_PARIS);
		Interval test = base.withEndMillis(1);
	}
	
	public void testWithEndMillis_long1e() {
		Interval base = new Interval(-1, TEST_TIME2, COPTIC_PARIS);
		Interval test = base.withEndMillis(-1);
	}
	
	public static void main(String[] args) {
		TestInterval_Basics3 t = new TestInterval_Basics3();
		t.testWithEndMillis_long1();
		t.testWithEndMillis_long3();
		
		t.testWithEndMillis_long1b();
		t.testWithEndMillis_long1c();
		t.testWithEndMillis_long1d();
		t.testWithEndMillis_long1e();
	}

}
