package org.joda.time;

import junit.framework.TestCase;

public class TestMutableInterval_Updates8 extends TestCase {

	private static final DateTimeZone PARIS = DateTimeZone.forID("Europe/Paris");
	private static final DateTimeZone LONDON = DateTimeZone.forID("Europe/London");

	long y2002days = 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365
			+ 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365;
	long y2003days = 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365
			+ 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365;

	// 2002-06-09
	private long TEST_TIME_NOW = (y2002days + 31L + 28L + 31L + 30L + 31L + 9L - 1L) * DateTimeConstants.MILLIS_PER_DAY;

	// 2002-04-05
	private long TEST_TIME1 = (y2002days + 31L + 28L + 31L + 5L - 1L) * DateTimeConstants.MILLIS_PER_DAY
			+ 12L * DateTimeConstants.MILLIS_PER_HOUR + 24L * DateTimeConstants.MILLIS_PER_MINUTE;

	// 2003-05-06
	private long TEST_TIME2 = (y2003days + 31L + 28L + 31L + 30L + 6L - 1L) * DateTimeConstants.MILLIS_PER_DAY
			+ 14L * DateTimeConstants.MILLIS_PER_HOUR + 28L * DateTimeConstants.MILLIS_PER_MINUTE;

	protected void setUp() throws Exception {
		DateTimeUtils.setCurrentMillisFixed(TEST_TIME_NOW);
		DateTimeZone.setDefault(LONDON);
	}

	public void testSetDurationAfterStart_long1() {
		MutableInterval test = new MutableInterval(TEST_TIME1, TEST_TIME2);
		test.setDurationAfterStart(123L);
	}

	public void testSeDurationAfterStart_long2() {
		MutableInterval test = new MutableInterval(TEST_TIME1, TEST_TIME2);
		test.setDurationAfterStart(-1);
	}
	
	public void test1b() {
		MutableInterval test = new MutableInterval(TEST_TIME1, TEST_TIME2);
		test.setDurationAfterStart(122L);
	}
	
	public void test1c() {
		MutableInterval test = new MutableInterval(TEST_TIME1, TEST_TIME2);
		test.setDurationAfterStart(124L);
	}
	
	public void test1d() {
		MutableInterval test = new MutableInterval(TEST_TIME1, TEST_TIME2);
		test.setDurationAfterStart(0L);
	}
	
	public void test1e() {
		MutableInterval test = new MutableInterval(TEST_TIME1, TEST_TIME2);
		test.setDurationAfterStart(1L);
	}
	
	public static void main(String[] args) throws Exception {
		TestMutableInterval_Updates8 t = new TestMutableInterval_Updates8();
		t.setUp();
		t.testSetDurationAfterStart_long1();
		
		t.test1b();
		t.test1c();
		t.test1d();
		t.test1e();
	}

}
