/*
 * Copyright (C) 2014 Pedro Vicente Gómez Sánchez.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.github.pedrovgs.problem7;

import org.junit.Before;
import org.junit.Test;

import static org.junit.Assert.assertEquals;

/**
 * @author Pedro Vicente Gómez Sánchez.
 */
public class FibonacciNumbersTest3 {

  private FibonacciNumbers fibonacciNumbers;

  @Before public void setUp() {
    fibonacciNumbers = new FibonacciNumbers();
  }

  @Test
  public void shouldNotAcceptNegativeValuesRecursiveWithCatching() {
    fibonacciNumbers.getRecursiveWithCaching(-1);
  }

  @Test public void fourthNumberInFibonacciSequenceIsThreeRecursiveWithCatching() {
	fibonacciNumbers.getRecursiveWithCaching(5);
    // assertEquals(5, fibonacciNumbers.getRecursiveWithCatching(5));
  }

  @Test public void eleventhNumberInFibonacciSequenceIsRecursiveWithCatching() {
	fibonacciNumbers.getRecursiveWithCaching(12);
    // assertEquals(144, fibonacciNumbers.getRecursiveWithCatching(12));
  }
  
  public static void main(String[] args) {
	  FibonacciNumbersTest3 t = new FibonacciNumbersTest3();
	  t.setUp();
	  t.fourthNumberInFibonacciSequenceIsThreeRecursiveWithCatching();
	  t.eleventhNumberInFibonacciSequenceIsRecursiveWithCatching();
  }
  
}
