package com.github.pedrovgs.problem18;

import com.github.pedrovgs.binarytree.BinaryNode;
import org.junit.Before;
import org.junit.Test;

import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

/**
 * @author Pedro Vicente Gómez Sánchez.
 */
public class IsBSTTest2 {

  private IsBST isBST;

  @Before public void setUp() {
    isBST = new IsBST();
  }

  @Test
  public void shouldNotAcceptNullBinaryTreesIterative() {
    isBST.checkIterative(null);
  }

  @Test public void shouldReturnTrueIfTheTreeContainsJustOneNodeIterative() {
    BinaryNode<Integer> root = new BinaryNode<Integer>(0);

    isBST.checkIterative(root);
    // assertTrue(isBST.checkIterative(root));
  }

  @Test public void shouldReturnFalseIfLeftNodesAreGraterThanRightNodesIterative() {
    BinaryNode<Integer> root = new BinaryNode<Integer>(0);
    BinaryNode<Integer> n1 = new BinaryNode<Integer>(1);
    BinaryNode<Integer> n2 = new BinaryNode<Integer>(2);
    root.setLeft(n2);
    root.setRight(n1);

    isBST.checkIterative(root);
    // assertFalse(isBST.checkIterative(root));
  }

  @Test public void shouldReturnTrueIfBinaryTreeIsBSTIterative() {
    BinaryNode<Integer> root = new BinaryNode<Integer>(0);
    BinaryNode<Integer> n1 = new BinaryNode<Integer>(1);
    BinaryNode<Integer> n2 = new BinaryNode<Integer>(2);
    n1.setLeft(root);
    n1.setRight(n2);

    isBST.checkIterative(n1);
    // assertTrue(isBST.checkIterative(n1));
  }
  
  public static void main(String[] args) {
	  IsBSTTest2 t = new IsBSTTest2();
	  t.setUp();
	  t.shouldReturnFalseIfLeftNodesAreGraterThanRightNodesIterative();
	  t.shouldReturnTrueIfBinaryTreeIsBSTIterative();
	  t.shouldReturnTrueIfTheTreeContainsJustOneNodeIterative();
  }
  
}
