/*
 * Copyright (C) 2014 Pedro Vicente Gómez Sánchez.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.github.pedrovgs.problem26;

import com.github.pedrovgs.problem26.Palindromes;
import org.junit.Before;
import org.junit.Test;

import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

/**
 * @author Pedro Vicente Gómez Sánchez.
 */
public class PalindromesTest1 {

  private Palindromes palindromes;

  @Before
  public void setUp(){
    palindromes = new Palindromes();
  }

  @Test
  public void shouldNotAcceptNullStrings(){
    palindromes.evaluate(null);
  }

  @Test
  public void shouldReturnTrueIfInputStringIsEmpty(){
	palindromes.evaluate("");
    // assertTrue(palindromes.evaluate(""));
  }

  @Test
  public void shouldReturnFalseIfInputIsPalindrome(){
	  palindromes.evaluate("pedro");
    // assertFalse(palindromes.evaluate("pedro"));
  }

  @Test
  public void shouldReturnTrueIfInputIsPalindrome(){
	  palindromes.evaluate("ana");
    //assertTrue(palindromes.evaluate("ana"));
  }
  
  public static void main(String[] args) {
	  PalindromesTest1 t = new PalindromesTest1();
	  t.setUp();
	  t.shouldReturnFalseIfInputIsPalindrome();
	  t.shouldReturnTrueIfInputIsPalindrome();
	  t.shouldReturnTrueIfInputStringIsEmpty();
  }

}
