package com.github.pedrovgs.problem10;

import java.util.HashSet;
import java.util.Set;
import org.junit.Before;
import org.junit.Test;

import static org.junit.Assert.assertArrayEquals;
import static org.junit.Assert.assertTrue;

/**
 * @author Pedro Vicente Gómez Sánchez.
 */
public class RemoveDuplicatesTest1 {

  private RemoveDuplicates removeDuplicates;

  @Before public void setUp() {
    this.removeDuplicates = new RemoveDuplicates();
  }

  @Test
  public void shouldNotAcceptNullArraysBasedOnSet() {
    removeDuplicates.removeUsingSet(null);
  }

  @Test public void shouldSupportEmptyArraysBasedOnSet() {
    Integer[] array = new Integer[0];

    Integer[] result = removeDuplicates.removeUsingSet(array);

    // assertArrayEquals(new Integer[0], result);
  }

  @Test public void shouldReturnAnArrayWithJustOneElementIfInputJustContainsOneElementBasedOnSet() {
    Integer[] array = { 1 };

    Integer[] result = removeDuplicates.removeUsingSet(array);

    Integer[] expected = { 1 };
    // assertArrayEquals(expected, result);
  }

  @Test public void shouldSupportArraysWithoutDuplicatedElementsBasedOnSet() {
    Integer[] array = { 1, 2, 3 };

    Integer[] result = removeDuplicates.removeUsingSet(array);

    // assertTrue(containsUniqueElements(result));
  }

  @Test
  public void shouldReturnAnArrayWithJustOneElementIfTheArrayIsFullOfTheSameElementBasedOnSet() {
    Integer[] array = { 1, 1, 1, 1, 1 };

    Integer[] result = removeDuplicates.removeUsingSet(array);

    // assertTrue(containsUniqueElements(result));
  }

  @Test public void shouldRemoveDuplicatesIfTheInputIsSortedBasedOnSet() {
    Integer[] array = { 1, 2, 3, 3, 4, 4, 6, 6 };

    Integer[] result = removeDuplicates.removeUsingSet(array);

    // assertTrue(containsUniqueElements(result));
  }

  @Test public void shouldRemoveDuplicatesIfTheInputIsNotSortedBasedOnSet() {
    Integer[] array = { 1, 1, 5, 6, 2, 3 };

    Integer[] result = removeDuplicates.removeUsingSet(array);

    // assertTrue(containsUniqueElements(result));
  }

  private boolean containsUniqueElements(Integer[] result) {
    Set<Integer> elements = new HashSet<Integer>();
    for (int i : result) {
      if (elements.contains(i)) {
        return false;
      }
    }
    return true;
  }
  
  public static void main(String[] args) {
	  RemoveDuplicatesTest1 t = new RemoveDuplicatesTest1();
	  t.setUp();
	  t.shouldSupportEmptyArraysBasedOnSet();
	  t.shouldReturnAnArrayWithJustOneElementIfInputJustContainsOneElementBasedOnSet();
	  t.shouldSupportArraysWithoutDuplicatedElementsBasedOnSet();
	  t.shouldReturnAnArrayWithJustOneElementIfTheArrayIsFullOfTheSameElementBasedOnSet();
	  t.shouldRemoveDuplicatesIfTheInputIsSortedBasedOnSet();
	  t.shouldRemoveDuplicatesIfTheInputIsNotSortedBasedOnSet();
  }
}
