package org.joda.time;

import org.joda.time.field.UnsupportedDateTimeField;
import org.joda.time.field.UnsupportedDurationField;

import junit.framework.TestCase;

public class TestDateMidnight_Basics7 extends TestCase {

	public void test1() {
        DateMidnight test = new DateMidnight();
        test.property(DateTimeFieldType.year());
    }

	public void test2() {
		DateMidnight test = new DateMidnight();
		test.property(DateTimeFieldType.dayOfWeek());
	}

	public void test3() {
		DateMidnight test = new DateMidnight();
		test.property(DateTimeFieldType.weekOfWeekyear());
	}

	public void test4() {
		DateMidnight test = new DateMidnight();
		test.property(DateTimeFieldType.millisOfSecond());
	}
	
	public void test4b() {
		DateMidnight test = new DateMidnight();
		test.property(DateTimeFieldType.centuryOfEra());
	}

	public void test5() {
		DateTimeFieldType bad = new DateTimeFieldType("bad") {
			private static final long serialVersionUID = 1L;

			public DurationFieldType getDurationType() {
				return DurationFieldType.weeks();
			}

			public DurationFieldType getRangeDurationType() {
				return null;
			}

			public DateTimeField getField(Chronology chronology) {
				return UnsupportedDateTimeField.getInstance(this,
						UnsupportedDurationField.getInstance(getDurationType()));
			}
		};
		DateMidnight test = new DateMidnight();
		test.property(bad);
	}

	public void test6() {
		DateMidnight test = new DateMidnight();
		test.property(null);
	}

	public static void main(String[] args) {
		TestDateMidnight_Basics7 t = new TestDateMidnight_Basics7();
		t.test1();
		t.test2();
		t.test3();
		t.test4();
	}
	
}
