package org.joda.time;

import junit.framework.TestCase;

public class TestDateTimeUtils1 extends TestCase {

	public void test1() {
		YearMonthDay ymd = new YearMonthDay(2005, 6, 9);
		DateTimeUtils.isContiguous(ymd);
	}

	public void test2() {
		TimeOfDay tod = new TimeOfDay(12, 20, 30, 0);
		DateTimeUtils.isContiguous(tod);
	}

	public void test3() {
		Partial year = new Partial(DateTimeFieldType.year(), 2005);
		DateTimeUtils.isContiguous(year);
	}

	public void test4() {
		Partial hourOfDay = new Partial(DateTimeFieldType.hourOfDay(), 12);
		DateTimeUtils.isContiguous(hourOfDay);
	}

	public void test5() {
		Partial year = new Partial(DateTimeFieldType.year(), 2005);
		Partial yearHour = year.with(DateTimeFieldType.hourOfDay(), 12);
		DateTimeUtils.isContiguous(yearHour);
	}

	public void test6() {
		YearMonthDay ymd = new YearMonthDay(2005, 6, 9);
		Partial ymdd = new Partial(ymd).with(DateTimeFieldType.dayOfWeek(), 2);
		DateTimeUtils.isContiguous(ymdd);
	}

	public void test7() {
		Partial dd = new Partial(DateTimeFieldType.dayOfMonth(), 13).with(DateTimeFieldType.dayOfWeek(), 5);
		DateTimeUtils.isContiguous(dd);
	}

	public void test8() {
		DateTimeUtils.isContiguous((ReadablePartial) null);
	}
	
	public static void main(String[] args) {
		TestDateTimeUtils1 t = new TestDateTimeUtils1();
		t.test1();
		t.test2();
		t.test3();
		t.test4();
		t.test5();
		t.test6();
		t.test7();
	}

}
