package org.joda.time;

import org.joda.time.field.UnsupportedDateTimeField;
import org.joda.time.field.UnsupportedDurationField;

import junit.framework.TestCase;

public class TestDateTime_Basics11 extends TestCase {

	public void test1() {
        DateTime test = new DateTime();
        test.property(DateTimeFieldType.year());
    }

	public void test2() {
		DateTime test = new DateTime();
		test.property(DateTimeFieldType.dayOfWeek());
	}

	public void test3() {
		DateTime test = new DateTime();
		test.property(DateTimeFieldType.secondOfMinute());
	}

	public void test4() {
		DateTime test = new DateTime();
		test.property(DateTimeFieldType.millisOfSecond());
	}

	public void test5() {
		DateTime test = new DateTime();
		DateTimeFieldType bad = new DateTimeFieldType("bad") {
			private static final long serialVersionUID = 1L;

			public DurationFieldType getDurationType() {
				return DurationFieldType.weeks();
			}

			public DurationFieldType getRangeDurationType() {
				return null;
			}

			public DateTimeField getField(Chronology chronology) {
				return UnsupportedDateTimeField.getInstance(this,
						UnsupportedDurationField.getInstance(getDurationType()));
			}
		};
		test.property(bad);
	}

	public void test6() {
		DateTime test = new DateTime();
		test.property(null);
	}

	public static void main(String[] args) {
		TestDateTime_Basics11 t = new TestDateTime_Basics11();
		t.test1();
		t.test2();
		t.test3();
		t.test4();
	}
	
}
