package org.joda.time;

import org.joda.time.chrono.ISOChronology;

import junit.framework.TestCase;

public class TestDateTime_Basics5 extends TestCase {

	long y2002days = 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365
			+ 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365;

	// 2002-04-05
	private long TEST_TIME1 = (y2002days + 31L + 28L + 31L + 5L - 1L) * DateTimeConstants.MILLIS_PER_DAY
			+ 12L * DateTimeConstants.MILLIS_PER_HOUR + 24L * DateTimeConstants.MILLIS_PER_MINUTE;

	private static final DateTimeZone PARIS = DateTimeZone.forID("Europe/Paris");

	private static final ISOChronology ISO_UTC = ISOChronology.getInstanceUTC();
	private static final ISOChronology ISO_PARIS = ISOChronology.getInstance(PARIS);

	public void test1() {
		DateTime test = new DateTime(2002, 4, 5, 1, 2, 3, 4, ISO_UTC);
		test.withDate(2003, 5, 6);
	}

	public void test2() {
		DateTime test = new DateTime(TEST_TIME1);
		test.withDate(2003, 13, 1);
	}

	public void test3() {
		DateTime test = new DateTime(2015, 1, 10, 2, 55, 0, 0, ISO_PARIS);
		test.withDate(2010, 3, 28);
	}

	public void test4() {
		DateTime test = new DateTime(2015, 1, 28, 2, 55, 0, 0, ISO_PARIS);
		test.withDate(2010, 3, 28);
	}

	public void test5() {
		DateTime test = new DateTime(2015, 1, 28, 2, 55, 0, 0, ISO_PARIS);
		test.withDate(2010, 3, 10);
	}
	
	public static void main(String[] args) {
		TestDateTime_Basics5 t = new TestDateTime_Basics5();
		t.test1();
		t.test3();
		t.test4();
		t.test5();
	}

}
