package org.joda.time;

import org.joda.time.chrono.BuddhistChronology;
import org.joda.time.chrono.ISOChronology;

import junit.framework.TestCase;

public class TestDateTime_Basics7 extends TestCase {

	long y2002days = 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365
			+ 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365;

	// 2002-04-05
	private long TEST_TIME1 = (y2002days + 31L + 28L + 31L + 5L - 1L) * DateTimeConstants.MILLIS_PER_DAY
			+ 12L * DateTimeConstants.MILLIS_PER_HOUR + 24L * DateTimeConstants.MILLIS_PER_MINUTE;

	private static final DateTimeZone PARIS = DateTimeZone.forID("Europe/Paris");

	private static final ISOChronology ISO_PARIS = ISOChronology.getInstance(PARIS);
	private static final BuddhistChronology BUDDHIST_UTC = BuddhistChronology.getInstanceUTC();

	public void test1() {
		DateTime test = new DateTime(TEST_TIME1 - 12345L, BUDDHIST_UTC);
		test.withTime(12, 24, 0, 0);
	}

	public void test2() {
		DateTime test = new DateTime(TEST_TIME1);
		test.withTime(25, 1, 1, 1);
	}

	public void test3() {
		DateTime test = new DateTime(2010, 3, 28, 0, 0, 0, 0, ISO_PARIS);
		test.withTime(2, 55, 0, 0);
	}
	
	public static void main(String[] args) {
		TestDateTime_Basics7 t = new TestDateTime_Basics7();
		t.test1();
		t.test3();
	}

}
