package org.joda.time;

import org.joda.time.chrono.CopticChronology;

import junit.framework.TestCase;

public class TestInterval_Basics1 extends TestCase {
	
	private static final DateTimeZone PARIS = DateTimeZone.forID("Europe/Paris");
    private static final Chronology COPTIC_PARIS = CopticChronology.getInstance(PARIS);

	long y2002days = 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365
			+ 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365;
	long y2003days = 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365
			+ 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365;

	// 2002-06-09
	private long TEST_TIME_NOW = (y2002days + 31L + 28L + 31L + 30L + 31L + 9L - 1L) * DateTimeConstants.MILLIS_PER_DAY;

	// 2002-04-05
	private long TEST_TIME1 = (y2002days + 31L + 28L + 31L + 5L - 1L) * DateTimeConstants.MILLIS_PER_DAY
			+ 12L * DateTimeConstants.MILLIS_PER_HOUR + 24L * DateTimeConstants.MILLIS_PER_MINUTE;

	// 2003-05-06
	private long TEST_TIME2 = (y2003days + 31L + 28L + 31L + 30L + 6L - 1L) * DateTimeConstants.MILLIS_PER_DAY
			+ 14L * DateTimeConstants.MILLIS_PER_HOUR + 28L * DateTimeConstants.MILLIS_PER_MINUTE;

	public void testWithStartMillis_long1() {
		Interval base = new Interval(TEST_TIME1, TEST_TIME2, COPTIC_PARIS);
		Interval test = base.withStartMillis(TEST_TIME1 - 1);
	}

	public void testWithStartMillis_long2() {
		Interval test = new Interval(TEST_TIME1, TEST_TIME2);
		test.withStartMillis(TEST_TIME2 + 1);
	}

	public void testWithStartMillis_long3() {
		Interval base = new Interval(TEST_TIME1, TEST_TIME2, COPTIC_PARIS);
		Interval test = base.withStartMillis(TEST_TIME1);
	}
	
	public static void main(String[] args) {
		TestInterval_Basics1 t = new TestInterval_Basics1();
		t.testWithStartMillis_long1();
		t.testWithStartMillis_long3();
	}

}
