package org.joda.time;

import org.joda.time.chrono.CopticChronology;

import junit.framework.TestCase;

public class TestInterval_Basics5 extends TestCase {

	private static final DateTimeZone PARIS = DateTimeZone.forID("Europe/Paris");
	private static final Chronology COPTIC_PARIS = CopticChronology.getInstance(PARIS);

	long y2002days = 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365
			+ 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365;
	long y2003days = 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365
			+ 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365;

	// 2002-06-09
	private long TEST_TIME_NOW = (y2002days + 31L + 28L + 31L + 30L + 31L + 9L - 1L) * DateTimeConstants.MILLIS_PER_DAY;

	// 2002-04-05
	private long TEST_TIME1 = (y2002days + 31L + 28L + 31L + 5L - 1L) * DateTimeConstants.MILLIS_PER_DAY
			+ 12L * DateTimeConstants.MILLIS_PER_HOUR + 24L * DateTimeConstants.MILLIS_PER_MINUTE;

	// 2003-05-06
	private long TEST_TIME2 = (y2003days + 31L + 28L + 31L + 30L + 6L - 1L) * DateTimeConstants.MILLIS_PER_DAY
			+ 14L * DateTimeConstants.MILLIS_PER_HOUR + 28L * DateTimeConstants.MILLIS_PER_MINUTE;

	public void testWithDurationAfterStart1() throws Throwable {
		Duration dur = new Duration(TEST_TIME2 - TEST_TIME_NOW);
		Interval base = new Interval(TEST_TIME_NOW, TEST_TIME_NOW, COPTIC_PARIS);
		Interval test = base.withDurationAfterStart(dur);
	}

	public void testWithDurationAfterStart2() throws Throwable {
		Interval base = new Interval(TEST_TIME_NOW, TEST_TIME2, COPTIC_PARIS);
		Interval test = base.withDurationAfterStart(null);
	}

	public void testWithDurationAfterStart3() throws Throwable {
		Duration dur = new Duration(-1);
		Interval base = new Interval(TEST_TIME_NOW, TEST_TIME_NOW);
		base.withDurationAfterStart(dur);
	}

	public void testWithDurationAfterStart4() throws Throwable {
		Interval base = new Interval(TEST_TIME_NOW, TEST_TIME2, COPTIC_PARIS);
		Interval test = base.withDurationAfterStart(base.toDuration());
	}

	public static void main(String[] args) throws Throwable {
		TestInterval_Basics5 t = new TestInterval_Basics5();
		t.testWithDurationAfterStart1();
		t.testWithDurationAfterStart2();
		t.testWithDurationAfterStart4();
	}
	
}
