package org.joda.time;

import junit.framework.TestCase;

public class TestLocalDateTime_Basics1 extends TestCase {

	private int MILLIS_OF_DAY_UTC = (int) (10L * DateTimeConstants.MILLIS_PER_HOUR
			+ 20L * DateTimeConstants.MILLIS_PER_MINUTE + 30L * DateTimeConstants.MILLIS_PER_SECOND + 40L);

	private long TEST_TIME_NOW_UTC = (31L + 28L + 31L + 30L + 31L + 9L - 1L) * DateTimeConstants.MILLIS_PER_DAY
			+ MILLIS_OF_DAY_UTC;

	protected void setUp() throws Exception {
		DateTimeUtils.setCurrentMillisFixed(TEST_TIME_NOW_UTC);
	}
	
	public void test1() {
		LocalDateTime test = new LocalDateTime(1970, 6, 9, 10, 20, 30, 40);
		test.get(DateTimeFieldType.year());
	}

	public void test2() {
		LocalDateTime test = new LocalDateTime(1970, 6, 9, 10, 20, 30, 40);
		test.get(DateTimeFieldType.monthOfYear());
	}

	public void test3() {
		LocalDateTime test = new LocalDateTime(1970, 6, 9, 10, 20, 30, 40);
		test.get(DateTimeFieldType.dayOfMonth());
	}

	public void test4() {
		LocalDateTime test = new LocalDateTime(1970, 6, 9, 10, 20, 30, 40);
		test.get(DateTimeFieldType.dayOfWeek());
	}

	public void test5() {
		LocalDateTime test = new LocalDateTime(1970, 6, 9, 10, 20, 30, 40);
		test.get(DateTimeFieldType.dayOfYear());
	}

	public void test6() {
		LocalDateTime test = new LocalDateTime(1970, 6, 9, 10, 20, 30, 40);
		test.get(DateTimeFieldType.weekOfWeekyear());
	}

	public void test7() {
		LocalDateTime test = new LocalDateTime(1970, 6, 9, 10, 20, 30, 40);
		test.get(DateTimeFieldType.weekyear());
	}

	public void test8() {
		LocalDateTime test = new LocalDateTime(1970, 6, 9, 10, 20, 30, 40);
		test.get(DateTimeFieldType.hourOfDay());
	}

	public void test9() {
		LocalDateTime test = new LocalDateTime(1970, 6, 9, 10, 20, 30, 40);
		test.get(DateTimeFieldType.minuteOfHour());
	}

	public void test10() {
		LocalDateTime test = new LocalDateTime(1970, 6, 9, 10, 20, 30, 40);
		test.get(DateTimeFieldType.secondOfMinute());
	}

	public void test11() {
		LocalDateTime test = new LocalDateTime(1970, 6, 9, 10, 20, 30, 40);
		test.get(DateTimeFieldType.millisOfSecond());
	}

	public void test12() {
		LocalDateTime test = new LocalDateTime(1970, 6, 9, 10, 20, 30, 40);
		test.get(DateTimeFieldType.minuteOfDay());
	}

	public void test13() {
		LocalDateTime test = new LocalDateTime(1970, 6, 9, 10, 20, 30, 40);
		test.get(DateTimeFieldType.secondOfDay());
	}

	public void test14() {
		LocalDateTime test = new LocalDateTime(1970, 6, 9, 10, 20, 30, 40);
		test.get(DateTimeFieldType.millisOfDay());
	}

	public void test15() {
		LocalDateTime test = new LocalDateTime(1970, 6, 9, 10, 20, 30, 40);
		test.get(DateTimeFieldType.hourOfHalfday());
	}

	public void test16() {
		LocalDateTime test = new LocalDateTime(1970, 6, 9, 10, 20, 30, 40);
		test.get(DateTimeFieldType.halfdayOfDay());
	}

	public void test17() {
		LocalDateTime test = new LocalDateTime(1970, 6, 9, 12, 30);
		test.get(DateTimeFieldType.hourOfHalfday());
	}
	
	public void test18() {
		LocalDateTime test = new LocalDateTime(1970, 6, 9, 12, 30);
		test.get(DateTimeFieldType.clockhourOfHalfday());
	}
	
	public void test19() {
		LocalDateTime test = new LocalDateTime(1970, 6, 9, 12, 30);
		test.get(DateTimeFieldType.clockhourOfDay());
	}
	
	public void test20() {
		LocalDateTime test = new LocalDateTime(1970, 6, 9, 12, 30);
		test.get(DateTimeFieldType.halfdayOfDay());
	}
	
	public void test21() {
		LocalDateTime test = new LocalDateTime(1970, 6, 9, 14, 30);
		test.get(DateTimeFieldType.hourOfHalfday());
	}
	
	public void test22() {
		LocalDateTime test = new LocalDateTime(1970, 6, 9, 14, 30);
		test.get(DateTimeFieldType.clockhourOfHalfday());
	}
	
	public void test23() {
		LocalDateTime test = new LocalDateTime(1970, 6, 9, 14, 30);
		test.get(DateTimeFieldType.clockhourOfDay());
	}
	
	public void test24() {
		LocalDateTime test = new LocalDateTime(1970, 6, 9, 14, 30);
		test.get(DateTimeFieldType.halfdayOfDay());
	}
	
	public void test25() {
		LocalDateTime test = new LocalDateTime(1970, 6, 9, 0, 30);
		test.get(DateTimeFieldType.hourOfHalfday());
	}
	
	public void test26() {
		LocalDateTime test = new LocalDateTime(1970, 6, 9, 0, 30);
		test.get(DateTimeFieldType.clockhourOfHalfday());
	}
	
	public void test27() {
		LocalDateTime test = new LocalDateTime(1970, 6, 9, 0, 30);
		test.get(DateTimeFieldType.clockhourOfDay());
	}
	
	public void test28() {
		LocalDateTime test = new LocalDateTime(1970, 6, 9, 0, 30);
		test.get(DateTimeFieldType.halfdayOfDay());
	}
	
	public void test29() {
		LocalDateTime test = new LocalDateTime(1970, 6, 9, 0, 30);
		test.get(null);
	}
	
	public static void main(String[] args) {
		TestLocalDateTime_Basics1 t = new TestLocalDateTime_Basics1();
		t.test1();
		t.test2();
		t.test3();
		t.test4();
		t.test5();
		t.test6();
		t.test7();
		t.test8();
		t.test9();
		t.test10();
		t.test11();
		t.test12();
		t.test13();
		t.test14();
		t.test15();
		t.test16();
		t.test17();
		t.test18();
		t.test19();
		t.test20();
		t.test21();
		t.test22();
		t.test23();
		t.test24();
		t.test25();
		t.test26();
		t.test27();
		t.test28();
	}

}
