package org.joda.time;

import org.joda.time.chrono.CopticChronology;

import junit.framework.TestCase;

public class TestLocalDateTime_Basics4 extends TestCase {

	private static final DateTimeZone PARIS = DateTimeZone.forID("Europe/Paris");
	private static final Chronology COPTIC_PARIS = CopticChronology.getInstance(PARIS);

	private int MILLIS_OF_DAY_UTC = (int) (10L * DateTimeConstants.MILLIS_PER_HOUR
			+ 20L * DateTimeConstants.MILLIS_PER_MINUTE + 30L * DateTimeConstants.MILLIS_PER_SECOND + 40L);

	private long TEST_TIME_NOW_UTC = (31L + 28L + 31L + 30L + 31L + 9L - 1L) * DateTimeConstants.MILLIS_PER_DAY
			+ MILLIS_OF_DAY_UTC;

	protected void setUp() throws Exception {
		DateTimeUtils.setCurrentMillisFixed(TEST_TIME_NOW_UTC);
	}

	public void test1() {
		LocalDateTime test = new LocalDateTime(COPTIC_PARIS);
		test.getValue(0);
	}

	public void test2() {
		LocalDateTime test = new LocalDateTime(COPTIC_PARIS);
		test.getValue(1);
	}

	public void test3() {
		LocalDateTime test = new LocalDateTime(COPTIC_PARIS);
		test.getValue(2);
	}

	public void test4() {
		LocalDateTime test = new LocalDateTime(COPTIC_PARIS);
		test.getValue(3);
	}

	public void test5() {
		LocalDateTime test = new LocalDateTime(COPTIC_PARIS);
		test.getValue(-1);
	}
	
	public static void main(String[] args) throws Throwable {
		TestLocalDateTime_Basics4 t = new TestLocalDateTime_Basics4();
		t.setUp();
		t.test1();
		t.test2();
		t.test3();
		t.test4();
	}

}
