package org.joda.time;

import org.joda.time.chrono.GregorianChronology;

import junit.framework.TestCase;

public class TestLocalDateTime_Basics5 extends TestCase {

	private static final Chronology GREGORIAN_UTC = GregorianChronology.getInstanceUTC();

	private int MILLIS_OF_DAY_UTC = (int) (10L * DateTimeConstants.MILLIS_PER_HOUR
			+ 20L * DateTimeConstants.MILLIS_PER_MINUTE + 30L * DateTimeConstants.MILLIS_PER_SECOND + 40L);

	public void test1() {
		LocalDateTime test1 = new LocalDateTime(2005, 6, 2, 10, 20, 30, 40);
		LocalDateTime test1a = new LocalDateTime(2005, 6, 2, 10, 20, 30, 40);
		test1.compareTo(test1a);
	}

	public void test2() {
		LocalDateTime test1 = new LocalDateTime(2005, 6, 2, 10, 20, 30, 40);
		LocalDateTime test1a = new LocalDateTime(2005, 6, 2, 10, 20, 30, 40);
		test1a.compareTo(test1);
	}

	public void test3() {
		LocalDateTime test1 = new LocalDateTime(2005, 6, 2, 10, 20, 30, 40);
		LocalDateTime test1a = new LocalDateTime(2005, 6, 2, 10, 20, 30, 40);
		test1.compareTo(test1);
	}

	public void test4() {
		LocalDateTime test1 = new LocalDateTime(2005, 6, 2, 10, 20, 30, 40);
		LocalDateTime test1a = new LocalDateTime(2005, 6, 2, 10, 20, 30, 40);
		test1a.compareTo(test1a);
	}

	public void test5() {
		LocalDateTime test1 = new LocalDateTime(2005, 6, 2, 10, 20, 30, 40);
		LocalDateTime test2 = new LocalDateTime(2005, 7, 2, 10, 20, 30, 40);
		test1.compareTo(test2);
	}

	public void test6() {
		LocalDateTime test1 = new LocalDateTime(2005, 6, 2, 10, 20, 30, 40);
		LocalDateTime test2 = new LocalDateTime(2005, 7, 2, 10, 20, 30, 40);
		test2.compareTo(test1);
	}

	public void test7() {
		LocalDateTime test1 = new LocalDateTime(2005, 6, 2, 10, 20, 30, 40);
		LocalDateTime test3 = new LocalDateTime(2005, 7, 2, 10, 20, 30, 40, GREGORIAN_UTC);
		test1.compareTo(test3);
	}

	public void test8() {
		LocalDateTime test1 = new LocalDateTime(2005, 6, 2, 10, 20, 30, 40);
		LocalDateTime test3 = new LocalDateTime(2005, 7, 2, 10, 20, 30, 40, GREGORIAN_UTC);
		test3.compareTo(test1);
	}

	public void test9() {
		LocalDateTime test2 = new LocalDateTime(2005, 7, 2, 10, 20, 30, 40);
		LocalDateTime test3 = new LocalDateTime(2005, 7, 2, 10, 20, 30, 40, GREGORIAN_UTC);
		test3.compareTo(test2);
	}

	public void test10() {
		LocalDateTime test1 = new LocalDateTime(2005, 6, 2, 10, 20, 30, 40);
		DateTimeFieldType[] types = new DateTimeFieldType[] { DateTimeFieldType.year(), DateTimeFieldType.monthOfYear(),
				DateTimeFieldType.dayOfMonth(), DateTimeFieldType.millisOfDay(), };
		int[] values = new int[] { 2005, 6, 2, MILLIS_OF_DAY_UTC };
		Partial p = new Partial(types, values);
		test1.compareTo(p);
	}

	public void test11() {
		LocalDateTime test1 = new LocalDateTime(2005, 6, 2, 10, 20, 30, 40);
		test1.compareTo(null);
	}

	public void test12() {
		LocalDateTime test1 = new LocalDateTime(2005, 6, 2, 10, 20, 30, 40);
		YearMonthDay ymd = new YearMonthDay();
		test1.compareTo(ymd);
	}

	public void test13() {
		LocalDateTime test1 = new LocalDateTime(2005, 6, 2, 10, 20, 30, 40);
		TimeOfDay tod = new TimeOfDay();
		test1.compareTo(tod);
	}

	public void test14() {
		Partial partial = new Partial().with(DateTimeFieldType.centuryOfEra(), 1)
				.with(DateTimeFieldType.halfdayOfDay(), 0).with(DateTimeFieldType.dayOfMonth(), 9);
		new LocalDateTime(1970, 6, 9, 10, 20, 30, 40).compareTo(partial);
	}
	
	public static void main(String[] args) {
		TestLocalDateTime_Basics5 t = new TestLocalDateTime_Basics5();
		t.test1();
		t.test2();
		t.test3();
		t.test4();
		t.test5();
		t.test6();
		t.test7();
		t.test8();
		t.test9();
		t.test10();
	}

}
