package org.joda.time;

import java.util.Locale;

import junit.framework.TestCase;

public class TestLocalDate_Basics1 extends TestCase {

	private static final DateTimeZone LONDON = DateTimeZone.forID("Europe/London");

	private long TEST_TIME_NOW = (31L + 28L + 31L + 30L + 31L + 9L - 1L) * DateTimeConstants.MILLIS_PER_DAY;

	protected void setUp() throws Exception {
		DateTimeUtils.setCurrentMillisFixed(TEST_TIME_NOW);
		DateTimeZone.setDefault(LONDON);
		Locale.setDefault(Locale.ENGLISH);
	}

	public void test1() {
		LocalDate test = new LocalDate();
		test.get(DateTimeFieldType.year());
	}

	public void test2() {
		LocalDate test = new LocalDate();
		test.get(DateTimeFieldType.monthOfYear());
	}

	public void test3() {
		LocalDate test = new LocalDate();
		test.get(DateTimeFieldType.dayOfMonth());
	}

	public void test4() {
		LocalDate test = new LocalDate();
		test.get(DateTimeFieldType.dayOfWeek());
	}

	public void test5() {
		LocalDate test = new LocalDate();
		test.get(DateTimeFieldType.dayOfYear());
	}

	public void test6() {
		LocalDate test = new LocalDate();
		test.get(DateTimeFieldType.weekOfWeekyear());
	}

	public void test7() {
		LocalDate test = new LocalDate();
		test.get(DateTimeFieldType.weekyear());
	}

	public void test8() {
		LocalDate test = new LocalDate();
		test.get(null);
	}

	public void test9() {
		LocalDate test = new LocalDate();
		test.get(DateTimeFieldType.hourOfDay());
	}
	
	public static void main(String[] args) throws Exception {
		TestLocalDate_Basics1 t = new TestLocalDate_Basics1();
		t.setUp();
		t.test1();
		t.test2();
		t.test3();
		t.test4();
		t.test5();
		t.test6();
		t.test7();
	}

}
