package org.joda.time;

import org.joda.time.chrono.BuddhistChronology;
import org.joda.time.chrono.CopticChronology;

import junit.framework.TestCase;

public class TestLocalDate_Basics12 extends TestCase {
	
	private static final DateTimeZone PARIS = DateTimeZone.forID("Europe/Paris");
	private static final DateTimeZone TOKYO = DateTimeZone.forID("Asia/Tokyo");
	
	private static final Chronology COPTIC_PARIS = CopticChronology.getInstance(PARIS);
    private static final Chronology COPTIC_TOKYO = CopticChronology.getInstance(TOKYO);
    
    private static final Chronology BUDDHIST_PARIS = BuddhistChronology.getInstance(PARIS);

	public void testToLocalDateTime_LocalTime() {
		LocalDate base = new LocalDate(2005, 6, 9, COPTIC_PARIS); // PARIS
																	// irrelevant
		LocalTime tod = new LocalTime(12, 13, 14, 15, COPTIC_TOKYO);

		LocalDateTime test = base.toLocalDateTime(tod);
	}

	public void testToLocalDateTime_nullLocalTime() {
		LocalDate base = new LocalDate(2005, 6, 9, COPTIC_PARIS); // PARIS
																	// irrelevant

		base.toLocalDateTime((LocalTime) null);
	}

	public void testToLocalDateTime_wrongChronologyLocalTime() {
		LocalDate base = new LocalDate(2005, 6, 9, COPTIC_PARIS); // PARIS
																	// irrelevant
		LocalTime tod = new LocalTime(12, 13, 14, 15, BUDDHIST_PARIS); // PARIS
																		// irrelevant

		base.toLocalDateTime(tod);
	}
	
	public static void main(String[] args) throws Throwable {
		TestLocalDate_Basics12 t = new TestLocalDate_Basics12();
		t.testToLocalDateTime_LocalTime();
	}

}
