package org.joda.time;

import java.util.Locale;

import org.joda.time.chrono.CopticChronology;

import junit.framework.TestCase;

public class TestLocalDate_Basics4 extends TestCase {

	private static final DateTimeZone LONDON = DateTimeZone.forID("Europe/London");
	private static final DateTimeZone PARIS = DateTimeZone.forID("Europe/Paris");

	private long TEST_TIME_NOW = (31L + 28L + 31L + 30L + 31L + 9L - 1L) * DateTimeConstants.MILLIS_PER_DAY;
	
	private static final Chronology COPTIC_PARIS = CopticChronology.getInstance(PARIS);

	protected void setUp() throws Exception {
		DateTimeUtils.setCurrentMillisFixed(TEST_TIME_NOW);
		DateTimeZone.setDefault(LONDON);
		Locale.setDefault(Locale.ENGLISH);
	}
	
	public void test1() {
        LocalDate test = new LocalDate(COPTIC_PARIS);
        test.getValue(0);
    }

	public void test2() {
        LocalDate test = new LocalDate(COPTIC_PARIS);
        test.getValue(1);
	}
	
	public void test3() {
        LocalDate test = new LocalDate(COPTIC_PARIS);
        test.getValue(2);
	}
	
	public void test4() {
        LocalDate test = new LocalDate(COPTIC_PARIS);
        test.getValue(-1);
	}
	
	public void test5() {
        LocalDate test = new LocalDate(COPTIC_PARIS);
        test.getValue(3);
	}
	
	public static void main(String[] args) throws Exception {
		TestLocalDate_Basics4 t = new TestLocalDate_Basics4();
		t.setUp();
		t.test1();
		t.test2();
		t.test3();
	}

}
