package org.joda.time;

import org.joda.time.chrono.GregorianChronology;

import junit.framework.TestCase;

public class TestLocalDate_Basics5 extends TestCase {

	public void test1() {
		LocalDate test1 = new LocalDate(2005, 6, 2);
		LocalDate test1a = new LocalDate(2005, 6, 2);
		test1.compareTo(test1a);
	}

	public void test2() {
		LocalDate test1 = new LocalDate(2005, 6, 2);
		LocalDate test1a = new LocalDate(2005, 6, 2);
		test1a.compareTo(test1);
	}

	public void test3() {
		LocalDate test1 = new LocalDate(2005, 6, 2);
		LocalDate test1a = new LocalDate(2005, 6, 2);
		test1.compareTo(test1);
	}

	public void test4() {
		LocalDate test1 = new LocalDate(2005, 6, 2);
		LocalDate test1a = new LocalDate(2005, 6, 2);
		test1a.compareTo(test1a);
	}

	public void test5() {
		LocalDate test1 = new LocalDate(2005, 6, 2);
		LocalDate test2 = new LocalDate(2005, 7, 2);
		test1.compareTo(test2);
	}

	public void test6() {
		LocalDate test1 = new LocalDate(2005, 6, 2);
		LocalDate test2 = new LocalDate(2005, 7, 2);
		test2.compareTo(test1);
	}

	public void test7() {
		LocalDate test1 = new LocalDate(2005, 6, 2);
		LocalDate test3 = new LocalDate(2005, 7, 2, GregorianChronology.getInstanceUTC());
		test1.compareTo(test3);
	}

	public void test8() {
		LocalDate test1 = new LocalDate(2005, 6, 2);
		LocalDate test3 = new LocalDate(2005, 7, 2, GregorianChronology.getInstanceUTC());
		test3.compareTo(test1);
	}

	public void test9() {
		LocalDate test2 = new LocalDate(2005, 7, 2);
		LocalDate test3 = new LocalDate(2005, 7, 2, GregorianChronology.getInstanceUTC());
		test3.compareTo(test2);
	}

	public void test10() {
		DateTimeFieldType[] types = new DateTimeFieldType[] { DateTimeFieldType.year(), DateTimeFieldType.monthOfYear(),
				DateTimeFieldType.dayOfMonth(), };

		LocalDate test1 = new LocalDate(2005, 6, 2);
		int[] values = new int[] { 2005, 6, 2 };
		Partial p = new Partial(types, values);
		test1.compareTo(p);
	}

	public void test11() {
		LocalDate test1 = new LocalDate(2005, 6, 2);
		test1.compareTo(new YearMonthDay(2005, 6, 2));
	}
	
	public void test12() {
		LocalDate test1 = new LocalDate(2005, 6, 2);
		test1.compareTo(null);
	}
	
	public void test13() {
		LocalDate test1 = new LocalDate(2005, 6, 2);
		test1.compareTo(new TimeOfDay());
	}
	
	public void test14() {
		Partial partial = new Partial()
	            .with(DateTimeFieldType.centuryOfEra(), 1)
	            .with(DateTimeFieldType.halfdayOfDay(), 0)
	            .with(DateTimeFieldType.dayOfMonth(), 9);
		new LocalDate(1970, 6, 9).compareTo(partial);
	}
	
	public static void main(String[] args) {
		TestLocalDate_Basics5 t = new TestLocalDate_Basics5();
		t.test1();
		t.test2();
		t.test3();
		t.test4();
		t.test5();
		t.test6();
		t.test7();
		t.test8();
		t.test9();
		t.test10();
		t.test11();
	}
	
}
