package org.joda.time;

import java.util.Calendar;
import java.util.GregorianCalendar;

import junit.framework.TestCase;

public class TestLocalDate_Constructors1 extends TestCase {

	public void testFactory_fromCalendarFields() throws Exception {
		GregorianCalendar cal = new GregorianCalendar(1970, 1, 3, 4, 5, 6);
		cal.set(Calendar.MILLISECOND, 7);
		LocalDate.fromCalendarFields(cal);
	}

	public void testFactory_fromCalendarFields_beforeYearZero1() throws Exception {
		GregorianCalendar cal = new GregorianCalendar(1, 1, 3, 4, 5, 6);
		cal.set(Calendar.ERA, GregorianCalendar.BC);
		cal.set(Calendar.MILLISECOND, 7);
		LocalDate.fromCalendarFields(cal);
	}

	public void testFactory_fromCalendarFields_beforeYearZero3() throws Exception {
		GregorianCalendar cal = new GregorianCalendar(3, 1, 3, 4, 5, 6);
		cal.set(Calendar.ERA, GregorianCalendar.BC);
		cal.set(Calendar.MILLISECOND, 7);
		LocalDate.fromCalendarFields(cal);
	}

	public void testFactory_fromCalendarFields_null() throws Exception {
		LocalDate.fromCalendarFields((Calendar) null);
	}
	
	public static void main(String[] args) throws Throwable {
		TestLocalDate_Constructors1 t = new TestLocalDate_Constructors1();
		t.testFactory_fromCalendarFields();
		t.testFactory_fromCalendarFields_beforeYearZero1();
		t.testFactory_fromCalendarFields_beforeYearZero3();
	}

}
