package org.joda.time;

import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;

import junit.framework.TestCase;

public class TestLocalDate_Constructors2 extends TestCase {

	public void testFactory_fromDateFields_after1970() throws Exception {
		GregorianCalendar cal = new GregorianCalendar(1970, 1, 3, 4, 5, 6);
		cal.set(Calendar.MILLISECOND, 7);
		LocalDate.fromDateFields(cal.getTime());
	}

	public void testFactory_fromDateFields_before1970() throws Exception {
		GregorianCalendar cal = new GregorianCalendar(1969, 1, 3, 4, 5, 6);
		cal.set(Calendar.MILLISECOND, 7);
		LocalDate.fromDateFields(cal.getTime());
	}

	public void testFactory_fromDateFields_beforeYearZero1() throws Exception {
		GregorianCalendar cal = new GregorianCalendar(1, 1, 3, 4, 5, 6);
		cal.set(Calendar.ERA, GregorianCalendar.BC);
		cal.set(Calendar.MILLISECOND, 7);
		LocalDate.fromDateFields(cal.getTime());
	}

	public void testFactory_fromDateFields_beforeYearZero3() throws Exception {
		GregorianCalendar cal = new GregorianCalendar(3, 1, 3, 4, 5, 6);
		cal.set(Calendar.ERA, GregorianCalendar.BC);
		cal.set(Calendar.MILLISECOND, 7);
		LocalDate.fromDateFields(cal.getTime());
	}

	public void testFactory_fromDateFields_null() throws Exception {
		LocalDate.fromDateFields((Date) null);
	}
	
	public static void main(String[] args) throws Throwable {
		TestLocalDate_Constructors2 t = new TestLocalDate_Constructors2();
		t.testFactory_fromDateFields_after1970();
		t.testFactory_fromDateFields_before1970();
		t.testFactory_fromDateFields_beforeYearZero1();
		t.testFactory_fromDateFields_beforeYearZero3();
	}

}
