package org.joda.time;

import junit.framework.TestCase;

public class TestMutableDateTime_Adds1 extends TestCase {

	private static final DateTimeZone LONDON = DateTimeZone.forID("Europe/London");

	long y2002days = 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365
			+ 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365;
	long y2003days = 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365
			+ 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365;

	// 2002-06-09
	private long TEST_TIME_NOW = (y2002days + 31L + 28L + 31L + 30L + 31L + 9L - 1L) * DateTimeConstants.MILLIS_PER_DAY;

	// 2002-04-05
	private long TEST_TIME1 = (y2002days + 31L + 28L + 31L + 5L - 1L) * DateTimeConstants.MILLIS_PER_DAY
			+ 12L * DateTimeConstants.MILLIS_PER_HOUR + 24L * DateTimeConstants.MILLIS_PER_MINUTE;

	// 2003-05-06
	private long TEST_TIME2 = (y2003days + 31L + 28L + 31L + 30L + 6L - 1L) * DateTimeConstants.MILLIS_PER_DAY
			+ 14L * DateTimeConstants.MILLIS_PER_HOUR + 28L * DateTimeConstants.MILLIS_PER_MINUTE;

	public void testAdd_DurationFieldType_int1() {
		MutableDateTime test = new MutableDateTime(TEST_TIME1);
		test.add(DurationFieldType.years(), 8);
	}

	public void testAdd_DurationFieldType_int_dstOverlapSummer_addZero() {
		MutableDateTime test = new MutableDateTime(2011, 10, 30, 2, 30, 0, 0, DateTimeZone.forID("Europe/Berlin"));
		test.add(DurationFieldType.years(), 0);
	}

	public void testAdd_DurationFieldType_int_dstOverlapWinter_addZero() {
		MutableDateTime test = new MutableDateTime(2011, 10, 30, 2, 30, 0, 0, DateTimeZone.forID("Europe/Berlin"));
		test.addHours(1);
		test.add(DurationFieldType.years(), 0);
	}

	public void testAdd_DurationFieldType_int2() {
		MutableDateTime test = new MutableDateTime(TEST_TIME1);
		test.add((DurationFieldType) null, 0);
	}

	public void testAdd_DurationFieldType_int3() {
		MutableDateTime test = new MutableDateTime(TEST_TIME1);
		test.add((DurationFieldType) null, 6);
	}
	
	public static void main(String[] args) {
		TestMutableDateTime_Adds1 t = new TestMutableDateTime_Adds1();
		t.testAdd_DurationFieldType_int1();
		t.testAdd_DurationFieldType_int_dstOverlapSummer_addZero();
		t.testAdd_DurationFieldType_int_dstOverlapWinter_addZero();
	}

}
