package org.joda.time;

import org.joda.time.chrono.ISOChronology;

import junit.framework.TestCase;

public class TestMutableDateTime_Basics4 extends TestCase {

	public void testRounding1() {
		MutableDateTime test = new MutableDateTime(2002, 6, 9, 5, 6, 7, 8);
		test.setRounding(ISOChronology.getInstance().hourOfDay());
	}

	public void testRounding2() {
		MutableDateTime test = new MutableDateTime(2002, 6, 9, 5, 6, 7, 8);
		test.setRounding(ISOChronology.getInstance().hourOfDay(), MutableDateTime.ROUND_CEILING);
	}

	public void testRounding3() {
		MutableDateTime test = new MutableDateTime(2002, 6, 9, 5, 6, 7, 8);
		test.setRounding(ISOChronology.getInstance().hourOfDay(), MutableDateTime.ROUND_HALF_CEILING);
	}

	public void testRounding3b() {
		MutableDateTime test = new MutableDateTime(2002, 6, 9, 5, 30, 0, 0);
		test.setRounding(ISOChronology.getInstance().hourOfDay(), MutableDateTime.ROUND_HALF_CEILING);
	}

	public void testRounding4() {
		MutableDateTime test = new MutableDateTime(2002, 6, 9, 5, 6, 7, 8);
		test.setRounding(ISOChronology.getInstance().hourOfDay(), MutableDateTime.ROUND_HALF_FLOOR);
	}

	public void testRounding4b() {
		MutableDateTime test = new MutableDateTime(2002, 6, 9, 5, 30, 0, 0);
		test.setRounding(ISOChronology.getInstance().hourOfDay(), MutableDateTime.ROUND_HALF_FLOOR);
	}

	public void testRounding5() {
		MutableDateTime test = new MutableDateTime(2002, 6, 9, 5, 6, 7, 8);
		test.setRounding(ISOChronology.getInstance().hourOfDay(), MutableDateTime.ROUND_HALF_EVEN);
	}

	public void testRounding5b() {
		MutableDateTime test = new MutableDateTime(2002, 6, 9, 5, 30, 0, 0);
		test.setRounding(ISOChronology.getInstance().hourOfDay(), MutableDateTime.ROUND_HALF_EVEN);
	}

	public void testRounding5c() {
		MutableDateTime test = new MutableDateTime(2002, 6, 9, 4, 30, 0, 0);
		test.setRounding(ISOChronology.getInstance().hourOfDay(), MutableDateTime.ROUND_HALF_EVEN);
	}

	public void testRounding6() {
		MutableDateTime test = new MutableDateTime(2002, 6, 9, 5, 6, 7, 8);
		test.setRounding(ISOChronology.getInstance().hourOfDay(), MutableDateTime.ROUND_NONE);
	}

	public void testRounding7() {
		MutableDateTime test = new MutableDateTime(2002, 6, 9, 5, 6, 7, 8);
		test.setRounding(ISOChronology.getInstance().hourOfDay(), -1);
	}

	public void testRounding8() {
		MutableDateTime test = new MutableDateTime(2002, 6, 9, 5, 6, 7, 8);

		test.setRounding(ISOChronology.getInstance().hourOfDay(), MutableDateTime.ROUND_CEILING);
	}

	public void testRounding8b() {
		MutableDateTime test = new MutableDateTime(2002, 6, 9, 5, 6, 7, 8);
		test.setRounding(ISOChronology.getInstance().hourOfDay(), MutableDateTime.ROUND_NONE);
	}

	public void testRounding8c() {
		MutableDateTime test = new MutableDateTime(2002, 6, 9, 5, 6, 7, 8);
		test.setRounding(null, -1);
	}

//	public void testRounding8d() {
//		MutableDateTime test = new MutableDateTime(2002, 6, 9, 5, 6, 7, 8);
//		test.setRounding(ISOChronology.getInstance().hourOfDay());
//	}
//
//	public void testRounding8e() {
//		MutableDateTime test = new MutableDateTime(2002, 6, 9, 5, 6, 7, 8);
//		test.setRounding(null);
//	}
	
	public static void main(String[] args) {
		TestMutableDateTime_Basics4 t = new TestMutableDateTime_Basics4();
		t.testRounding1();
		t.testRounding2();
		t.testRounding3();
		t.testRounding3b();
		t.testRounding4();
		t.testRounding4b();
		t.testRounding5();
		t.testRounding5b();
		t.testRounding5c();
		t.testRounding6();
		t.testRounding8();
		t.testRounding8b();
		t.testRounding8c();
	}

}
