package org.joda.time;

import org.joda.time.field.UnsupportedDateTimeField;
import org.joda.time.field.UnsupportedDurationField;

import junit.framework.TestCase;

public class TestMutableDateTime_Basics5 extends TestCase {

	public void testProperty() {
		MutableDateTime test = new MutableDateTime();
		test.property(DateTimeFieldType.year());
	}

	public void test2() {
		MutableDateTime test = new MutableDateTime();
		test.property(DateTimeFieldType.dayOfWeek());
	}

	public void test3() {
		MutableDateTime test = new MutableDateTime();
		test.property(DateTimeFieldType.secondOfMinute());
	}

	public void test4() {
		MutableDateTime test = new MutableDateTime();
		test.property(DateTimeFieldType.millisOfSecond());
	}

	public void test5() {
		MutableDateTime test = new MutableDateTime();
		DateTimeFieldType bad = new DateTimeFieldType("bad") {
			private static final long serialVersionUID = 1L;

			public DurationFieldType getDurationType() {
				return DurationFieldType.weeks();
			}

			public DurationFieldType getRangeDurationType() {
				return null;
			}

			public DateTimeField getField(Chronology chronology) {
				return UnsupportedDateTimeField.getInstance(this,
						UnsupportedDurationField.getInstance(getDurationType()));
			}
		};
		test.property(bad);
	}

	public void test6() {
		MutableDateTime test = new MutableDateTime();
		test.property(null);
	}
	
	public static void main(String[] args) {
		TestMutableDateTime_Basics5 t = new TestMutableDateTime_Basics5();
		t.testProperty();
		t.test2();
		t.test3();
		t.test4();
	}

}
