package org.joda.time;

import junit.framework.TestCase;

public class TestMutableInterval_Updates2 extends TestCase {

	private static final DateTimeZone PARIS = DateTimeZone.forID("Europe/Paris");
	private static final DateTimeZone LONDON = DateTimeZone.forID("Europe/London");

	long y2002days = 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365
			+ 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365;
	long y2003days = 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365
			+ 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365 + 365 + 366 + 365 + 365;

	// 2002-06-09
	private long TEST_TIME_NOW = (y2002days + 31L + 28L + 31L + 30L + 31L + 9L - 1L) * DateTimeConstants.MILLIS_PER_DAY;

	// 2002-04-05
	private long TEST_TIME1 = (y2002days + 31L + 28L + 31L + 5L - 1L) * DateTimeConstants.MILLIS_PER_DAY
			+ 12L * DateTimeConstants.MILLIS_PER_HOUR + 24L * DateTimeConstants.MILLIS_PER_MINUTE;

	// 2003-05-06
	private long TEST_TIME2 = (y2003days + 31L + 28L + 31L + 30L + 6L - 1L) * DateTimeConstants.MILLIS_PER_DAY
			+ 14L * DateTimeConstants.MILLIS_PER_HOUR + 28L * DateTimeConstants.MILLIS_PER_MINUTE;

	protected void setUp() throws Exception {
		DateTimeUtils.setCurrentMillisFixed(TEST_TIME_NOW);
		DateTimeZone.setDefault(LONDON);
	}

	public void testSetInterval_RI_RI1() {
		MutableInterval test = new MutableInterval(TEST_TIME1, TEST_TIME2);
		test.setInterval(new Instant(TEST_TIME1 - 1), new Instant(TEST_TIME2 + 1));
	}

	public void testSetInterval_RI_RI2() {
		MutableInterval test = new MutableInterval(TEST_TIME1, TEST_TIME2);
		test.setInterval(new Instant(TEST_TIME1 - 1), new Instant(TEST_TIME1 - 2));
	}

	public void testSetInterval_RI_RI3() {
		MutableInterval test = new MutableInterval(TEST_TIME1, TEST_TIME2);
		test.setInterval(null, new Instant(TEST_TIME2 + 1));
	}

	public void testSetInterval_RI_RI4() {
		MutableInterval test = new MutableInterval(TEST_TIME1, TEST_TIME2);
		test.setInterval(new Instant(TEST_TIME1 - 1), null);
	}

	public void testSetInterval_RI_RI5() {
		MutableInterval test = new MutableInterval(TEST_TIME1, TEST_TIME2);
		test.setInterval(null, null);
	}
	
	public static void main(String[] args) throws Exception {
		TestMutableInterval_Updates2 t = new TestMutableInterval_Updates2();
		t.setUp();
		t.testSetInterval_RI_RI1();
		t.testSetInterval_RI_RI3();
		t.testSetInterval_RI_RI4();
		t.testSetInterval_RI_RI5();
	}

}
