package org.joda.time;

import junit.framework.TestCase;

public class TestMutablePeriod_Updates7 extends TestCase {

	public void testAdd_RP1() {
		MutablePeriod test = new MutablePeriod(100L);
		test.add(new Period(100L));
	}

	public void testAdd_RP2() {
		MutablePeriod test = new MutablePeriod(100L, PeriodType.standard()); // All
																				// type
		test.add(new Period(1, 2, 3, 4, 5, 6, 7, 0, PeriodType.standard().withMillisRemoved()));
	}

	public void testAdd_RP3() {
		MutablePeriod test = new MutablePeriod(100L, PeriodType.standard());
		test.add(new Period(0L));
	}

	public void testAdd_RP4() {
		MutablePeriod test = new MutablePeriod(1, 2, 0, 4, 5, 6, 7, 8, PeriodType.yearMonthDayTime());
		test.add(new Period(1, 2, 3, 4, 5, 6, 7, 8)); // cannot set weeks
	}

	public void testAdd_RP5() {
		MutablePeriod test = new MutablePeriod(1, 2, 0, 4, 5, 6, 7, 8, PeriodType.yearMonthDayTime());
		test.add(new Period(1, 2, 0, 4, 5, 6, 7, 8)); // can set weeks as zero
	}

	public void testAdd_RP6() {
		MutablePeriod test = new MutablePeriod(1, 2, 3, 4, 5, 6, 7, 8);
		test.add((ReadablePeriod) null);
	}
	
	public static void main(String[] args) {
		TestMutablePeriod_Updates7 t = new TestMutablePeriod_Updates7();
		t.testAdd_RP1();
		t.testAdd_RP2();
		t.testAdd_RP3();
		t.testAdd_RP5();
		t.testAdd_RP6();
	}

}
