package org.joda.time;

import org.joda.time.chrono.ISOChronology;

import junit.framework.TestCase;

public class TestPartial_Basics2 extends TestCase {
	
	private static final Chronology ISO_UTC = ISOChronology.getInstanceUTC();
	
	private Partial createHourMinPartial() {
        return createHourMinPartial(ISO_UTC);
    }

    private Partial createHourMinPartial(Chronology chrono) {
        return createHourMinPartial(10, 20, chrono);
    }

    private Partial createHourMinPartial2(Chronology chrono) {
        return createHourMinPartial(15, 20, chrono);
    }

    private Partial createHourMinPartial(int hour, int min, Chronology chrono) {
        return new Partial(
            new DateTimeFieldType[] {DateTimeFieldType.hourOfDay(), DateTimeFieldType.minuteOfHour()},
            new int[] {hour, min},
            chrono);
    }
	
	public void testGetFieldType() {
        Partial test = createHourMinPartial();
        test.getFieldType(0);
    }
	
	public void test2() {
		Partial test = createHourMinPartial();
		test.getFieldType(1);
	}
	
	public void test3() {
		Partial test = createHourMinPartial();
		test.getFieldType(-1);
	}
	
	public void test4() {
		Partial test = createHourMinPartial();
		test.getFieldType(2);
	}
	
	public static void main(String[] args) {
		TestPartial_Basics2 t = new TestPartial_Basics2();
		t.testGetFieldType();
		t.test2();
	}

}
