package org.joda.time;

import org.joda.time.chrono.ISOChronology;

import junit.framework.TestCase;

public class TestPartial_Match1 extends TestCase {
	
	private static final Chronology ISO_UTC = ISOChronology.getInstanceUTC();

	public void testIsMatch_Partial() {
		// Year=2005, Month=7 (July), DayOfWeek=2 (Tuesday)
		Partial test = createYMDwPartial(ISO_UTC, 2005, 7, 2);
		LocalDate partial = new LocalDate(2005, 7, 5);
		test.isMatch(partial);
	}

	public void test2() {
		Partial test = createYMDwPartial(ISO_UTC, 2005, 7, 2);
		LocalDate partial = new LocalDate(2005, 7, 4);
		test.isMatch(partial);
	}

	public void test3() {
		Partial test = createYMDwPartial(ISO_UTC, 2005, 7, 2);
		LocalDate partial = new LocalDate(2005, 7, 6);
		test.isMatch(partial);
	}

	public void test4() {
		Partial test = createYMDwPartial(ISO_UTC, 2005, 7, 2);
		LocalDate partial = new LocalDate(2005, 7, 12);
		test.isMatch(partial);
	}

	public void test5() {
		Partial test = createYMDwPartial(ISO_UTC, 2005, 7, 2);
		LocalDate partial = new LocalDate(2005, 7, 19);
		test.isMatch(partial);
	}

	public void test6() {
		Partial test = createYMDwPartial(ISO_UTC, 2005, 7, 2);
		LocalDate partial = new LocalDate(2005, 7, 26);
		test.isMatch(partial);
	}

	public void test7() {
		Partial test = createYMDwPartial(ISO_UTC, 2005, 7, 2);
		LocalDate partial = new LocalDate(2005, 8, 2);
		test.isMatch(partial);
	}

	public void test8() {
		Partial test = createYMDwPartial(ISO_UTC, 2005, 7, 2);
		LocalDate partial = new LocalDate(2006, 7, 5);
		test.isMatch(partial);
	}

	public void test9() {
		Partial test = createYMDwPartial(ISO_UTC, 2005, 7, 2);
		LocalDate partial = new LocalDate(2005, 6, 5);
		test.isMatch(partial);
	}

	public void test10() {
		Partial test = createYMDwPartial(ISO_UTC, 2005, 7, 2);
		test.isMatch((ReadablePartial) null);
	}

	// -----------------------------------------------------------------------
	private Partial createYMDwPartial(Chronology chrono, int year, int month, int dow) {
		return new Partial(new DateTimeFieldType[] { DateTimeFieldType.year(), DateTimeFieldType.monthOfYear(),
				DateTimeFieldType.dayOfWeek() }, new int[] { year, month, dow }, chrono);
	}
	
	public static void main(String[] args) {
		TestPartial_Match1 t = new TestPartial_Match1();
		t.testIsMatch_Partial();
		t.test2();
		t.test3();
		t.test4();
		t.test5();
		t.test6();
		t.test7();
		t.test8();
		t.test9();
	}

}
