package org.joda.time;

import junit.framework.TestCase;

public class TestPeriodType1 extends TestCase {

	public void testForFields1() throws Exception {
		PeriodType.forFields(new DurationFieldType[] { DurationFieldType.years(), });
	}

	public void test1b() throws Exception {
		PeriodType.forFields(new DurationFieldType[] { DurationFieldType.months(), });
	}

	public void test1c() throws Exception {
		PeriodType.forFields(new DurationFieldType[] { DurationFieldType.weeks(), });
	}

	public void test1d() throws Exception {
		PeriodType.forFields(new DurationFieldType[] { DurationFieldType.days(), });
	}

	public void test1e() throws Exception {
		PeriodType.forFields(new DurationFieldType[] { DurationFieldType.hours(), });
	}

	public void test1f() throws Exception {
		PeriodType.forFields(new DurationFieldType[] { DurationFieldType.minutes(), });
	}

	public void test1g() throws Exception {
		PeriodType.forFields(new DurationFieldType[] { DurationFieldType.seconds(), });
	}

	public void test1h() throws Exception {
		PeriodType.forFields(new DurationFieldType[] { DurationFieldType.millis(), });
	}

	public void testForFields2() throws Exception {
		DurationFieldType[] types = new DurationFieldType[] { DurationFieldType.years(), DurationFieldType.hours(), };
		PeriodType type = PeriodType.forFields(types);
	}

	public void testForFields3() throws Exception {
		DurationFieldType[] types = new DurationFieldType[] { DurationFieldType.months(), DurationFieldType.weeks(), };
		PeriodType type = PeriodType.forFields(types);
	}

	public void testForFields4() throws Exception {
		DurationFieldType[] types = new DurationFieldType[] { DurationFieldType.weeks(), DurationFieldType.days(), // adding
																													// this
																													// makes
																													// this
																													// test
																													// unique,
																													// so
																													// cache
																													// is
																													// not
																													// pre-populated
				DurationFieldType.months(), };
		PeriodType type = PeriodType.forFields(types);
	}

	public void test4b() throws Exception {
		DurationFieldType[] types2 = new DurationFieldType[] { DurationFieldType.months(), DurationFieldType.days(),
				DurationFieldType.weeks(), };

		PeriodType type2 = PeriodType.forFields(types2);
	}

	public void testForFields5() throws Exception {
		DurationFieldType[] types = new DurationFieldType[] { DurationFieldType.centuries(),
				DurationFieldType.months(), };
		PeriodType.forFields(types);
	}

	public void testForFields6() throws Exception {
		DurationFieldType[] types = null;
		PeriodType.forFields(types);
	}

	public void test6b() {
		DurationFieldType[] types = new DurationFieldType[0];
		PeriodType.forFields(types);
	}

	public void test6c() {
		DurationFieldType[] types = new DurationFieldType[] { null, DurationFieldType.months(), };
		PeriodType.forFields(types);
	}

	public void test6d() {
		DurationFieldType[] types = new DurationFieldType[] { DurationFieldType.months(), null, };
		PeriodType.forFields(types);
	}

	// ensure hash key distribution
	public void testForFields7() throws Exception {
		DurationFieldType[] types = new DurationFieldType[] { DurationFieldType.weeks(), DurationFieldType.months(), };
		PeriodType type = PeriodType.forFields(types);
	}

	public void test7b() {
		DurationFieldType[] types2 = new DurationFieldType[] { DurationFieldType.seconds(), };
		PeriodType type2 = PeriodType.forFields(types2);
	}
	
	public static void main(String[] args) throws Exception {
		TestPeriodType1 t = new TestPeriodType1();
		t.testForFields1();
		t.testForFields2();
		t.testForFields3();
		t.testForFields4();
		t.testForFields7();
		t.test1b();
		t.test1c();
		t.test1d();
		t.test1e();
		t.test1f();
		t.test1g();
		t.test1h();
		t.test4b();
		t.test7b();
	}

}
