package org.joda.time;

import junit.framework.TestCase;

public class TestPeriod_Basics28 extends TestCase {

	public void testNormalizedStandard_yearMonth1() {
		Period test = new Period(1, 15, 0, 0, 0, 0, 0, 0);
		Period result = test.normalizedStandard();
	}

	public void testNormalizedStandard_yearMonth2() {
		Period test = new Period(Integer.MAX_VALUE, 15, 0, 0, 0, 0, 0, 0);
		test.normalizedStandard();
	}

	public void testNormalizedStandard_weekDay1() {
		Period test = new Period(0, 0, 1, 12, 0, 0, 0, 0);
		Period result = test.normalizedStandard();
	}

	public void testNormalizedStandard_weekDay2() {
		Period test = new Period(0, 0, Integer.MAX_VALUE, 7, 0, 0, 0, 0);
		test.normalizedStandard();
	}

	public void testNormalizedStandard_yearMonthWeekDay() {
		Period test = new Period(1, 15, 1, 12, 0, 0, 0, 0);
		Period result = test.normalizedStandard();
	}

	public void testNormalizedStandard_yearMonthDay() {
		Period test = new Period(1, 15, 0, 36, 0, 0, 0, 0);
		Period result = test.normalizedStandard();
	}

	public void testNormalizedStandard_negative() {
		Period test = new Period(0, 0, 0, 0, 2, -10, 0, 0);
		Period result = test.normalizedStandard();
	}

	public void testNormalizedStandard_fullNegative() {
		Period test = new Period(0, 0, 0, 0, 1, -70, 0, 0);
		Period result = test.normalizedStandard();
	}
	
	public static void main(String[] args) {
		TestPeriod_Basics28 t = new TestPeriod_Basics28();
		t.testNormalizedStandard_yearMonth1();
		t.testNormalizedStandard_weekDay1();
		t.testNormalizedStandard_yearMonthWeekDay();
		t.testNormalizedStandard_yearMonthDay();
		t.testNormalizedStandard_negative();
		t.testNormalizedStandard_fullNegative();
	}

}
