package org.joda.time;

import junit.framework.TestCase;

public class TestPeriod_Basics29 extends TestCase {

	public void testNormalizedStandard_periodType_yearMonth1() {
		Period test = new Period(1, 15, 0, 0, 0, 0, 0, 0);
		Period result = test.normalizedStandard((PeriodType) null);
	}

	public void testNormalizedStandard_periodType_yearMonth2() {
		Period test = new Period(Integer.MAX_VALUE, 15, 0, 0, 0, 0, 0, 0);
		test.normalizedStandard((PeriodType) null);
	}

	public void testNormalizedStandard_periodType_yearMonth3() {
		Period test = new Period(1, 15, 3, 4, 0, 0, 0, 0);
		test.normalizedStandard(PeriodType.dayTime());
	}

	public void testNormalizedStandard_periodType_weekDay1() {
		Period test = new Period(0, 0, 1, 12, 0, 0, 0, 0);
		Period result = test.normalizedStandard((PeriodType) null);
	}

	public void testNormalizedStandard_periodType_weekDay2() {
		Period test = new Period(0, 0, Integer.MAX_VALUE, 7, 0, 0, 0, 0);
		test.normalizedStandard((PeriodType) null);
	}

	public void testNormalizedStandard_periodType_weekDay3() {
		Period test = new Period(0, 0, 1, 12, 0, 0, 0, 0);
		Period result = test.normalizedStandard(PeriodType.dayTime());
	}

	public void testNormalizedStandard_periodType_yearMonthWeekDay() {
		Period test = new Period(1, 15, 1, 12, 0, 0, 0, 0);
		Period result = test.normalizedStandard(PeriodType.yearMonthDayTime());
	}

	public void testNormalizedStandard_periodType_yearMonthDay() {
		Period test = new Period(1, 15, 0, 36, 27, 0, 0, 0);
		Period result = test.normalizedStandard(PeriodType.yearMonthDayTime());
	}

	public void testNormalizedStandard_periodType_months1() {
		Period test = new Period(1, 15, 0, 0, 0, 0, 0, 0);
		Period result = test.normalizedStandard(PeriodType.months());
	}

	public void testNormalizedStandard_periodType_months2() {
		Period test = new Period(-2, 15, 0, 0, 0, 0, 0, 0);
		Period result = test.normalizedStandard(PeriodType.months());
	}

	public void testNormalizedStandard_periodType_months3() {
		Period test = new Period(0, 4, 0, 0, 0, 0, 0, 0);
		Period result = test.normalizedStandard(PeriodType.months());
	}

	public void testNormalizedStandard_periodType_years() {
		Period test = new Period(1, 15, 0, 0, 0, 0, 0, 0);
		test.normalizedStandard(PeriodType.years());
	}

	public void testNormalizedStandard_periodType_monthsWeeks() {
		PeriodType type = PeriodType.forFields(new DurationFieldType[] { DurationFieldType.months(),
				DurationFieldType.weeks(), DurationFieldType.days() });
		Period test = new Period(2, 4, 6, 0, 0, 0, 0, 0);
		Period result = test.normalizedStandard(type);
	}
	
	public static void main(String[] args) {
		TestPeriod_Basics29 t = new TestPeriod_Basics29();
		t.testNormalizedStandard_periodType_yearMonth1();
		t.testNormalizedStandard_periodType_weekDay1();
		t.testNormalizedStandard_periodType_weekDay3();
		t.testNormalizedStandard_periodType_yearMonthWeekDay();
		t.testNormalizedStandard_periodType_yearMonthDay();
		t.testNormalizedStandard_periodType_months1();
		t.testNormalizedStandard_periodType_months2();
		t.testNormalizedStandard_periodType_months3();
		t.testNormalizedStandard_periodType_monthsWeeks();
	}

}
