package org.joda.time;

import junit.framework.TestCase;

public class TestPeriod_Basics5 extends TestCase {

	public void testPlus() {
		Period base = new Period(1, 2, 3, 4, 5, 6, 7, 8);
		Period baseDaysOnly = new Period(0, 0, 0, 10, 0, 0, 0, 0, PeriodType.days());
		Period test = base.plus((ReadablePeriod) null);
	}

	public void test2() {
		Period base = new Period(1, 2, 3, 4, 5, 6, 7, 8);
		Period baseDaysOnly = new Period(0, 0, 0, 10, 0, 0, 0, 0, PeriodType.days());
		Period test = base.plus(Period.years(10));
	}

	public void test3() {
		Period base = new Period(1, 2, 3, 4, 5, 6, 7, 8);
		Period baseDaysOnly = new Period(0, 0, 0, 10, 0, 0, 0, 0, PeriodType.days());
		Period test = base.plus(Years.years(10));
	}

	public void test4() {
		Period base = new Period(1, 2, 3, 4, 5, 6, 7, 8);
		Period baseDaysOnly = new Period(0, 0, 0, 10, 0, 0, 0, 0, PeriodType.days());
		Period test = base.plus(Period.days(10));
	}

	public void test5() {
		Period base = new Period(1, 2, 3, 4, 5, 6, 7, 8);
		Period baseDaysOnly = new Period(0, 0, 0, 10, 0, 0, 0, 0, PeriodType.days());
		Period test = baseDaysOnly.plus(Period.years(0));
	}

	public void test6() {
		Period base = new Period(1, 2, 3, 4, 5, 6, 7, 8);
		Period baseDaysOnly = new Period(0, 0, 0, 10, 0, 0, 0, 0, PeriodType.days());
		Period test = baseDaysOnly.plus(baseDaysOnly);
	}

	public void test7() {
		Period base = new Period(1, 2, 3, 4, 5, 6, 7, 8);
		Period baseDaysOnly = new Period(0, 0, 0, 10, 0, 0, 0, 0, PeriodType.days());
		Period test = baseDaysOnly.plus(Period.years(1));
	}

	public void test8() {
		Period.days(Integer.MAX_VALUE).plus(Period.days(1));
	}

	public void test9() {
		Period.days(Integer.MIN_VALUE).plus(Period.days(-1));
	}

	public static void main(String[] args) {
		TestPeriod_Basics5 t = new TestPeriod_Basics5();
		t.testPlus();
		t.test2();
		t.test3();
		t.test4();
		t.test5();
		t.test6();
	}
}
