package org.joda.time;

import junit.framework.TestCase;

public class TestPeriod_Basics6 extends TestCase {

	public void testMinus() {
		Period base = new Period(1, 2, 3, 4, 5, 6, 7, 8);
		Period baseDaysOnly = new Period(0, 0, 0, 10, 0, 0, 0, 0, PeriodType.days());
		Period test = base.minus((ReadablePeriod) null);
	}

	public void test2() {
		Period base = new Period(1, 2, 3, 4, 5, 6, 7, 8);
		Period baseDaysOnly = new Period(0, 0, 0, 10, 0, 0, 0, 0, PeriodType.days());
		Period test = base.minus(Period.years(10));
	}

	public void test3() {
		Period base = new Period(1, 2, 3, 4, 5, 6, 7, 8);
		Period baseDaysOnly = new Period(0, 0, 0, 10, 0, 0, 0, 0, PeriodType.days());
		Period test = base.minus(Years.years(10));
	}

	public void test4() {
		Period base = new Period(1, 2, 3, 4, 5, 6, 7, 8);
		Period baseDaysOnly = new Period(0, 0, 0, 10, 0, 0, 0, 0, PeriodType.days());
		Period test = base.minus(Period.days(10));
	}

	public void test5() {
		Period base = new Period(1, 2, 3, 4, 5, 6, 7, 8);
		Period baseDaysOnly = new Period(0, 0, 0, 10, 0, 0, 0, 0, PeriodType.days());
		Period test = baseDaysOnly.minus(Period.years(0));
	}

	public void test6() {
		Period base = new Period(1, 2, 3, 4, 5, 6, 7, 8);
		Period baseDaysOnly = new Period(0, 0, 0, 10, 0, 0, 0, 0, PeriodType.days());
		Period test = baseDaysOnly.minus(baseDaysOnly);
	}

	public void test7() {
		Period base = new Period(1, 2, 3, 4, 5, 6, 7, 8);
		Period baseDaysOnly = new Period(0, 0, 0, 10, 0, 0, 0, 0, PeriodType.days());
		Period test = baseDaysOnly.minus(Period.years(1));
	}

	public void test8() {
		Period.days(Integer.MAX_VALUE).minus(Period.days(-1));
	}

	public void test9() {
		Period.days(Integer.MIN_VALUE).minus(Period.days(1));
	}
	
	public static void main(String[] args) {
		TestPeriod_Basics6 t = new TestPeriod_Basics6();
		t.testMinus();
		t.test2();
		t.test3();
		t.test4();
		t.test5();
		t.test6();
	}

}
