package org.joda.time;

import org.joda.time.chrono.BuddhistChronology;
import org.joda.time.chrono.CopticChronology;
import org.joda.time.chrono.ISOChronology;

import junit.framework.TestCase;

public class TestTimeOfDay_Basics2 extends TestCase {

	private static final DateTimeZone PARIS = DateTimeZone.forID("Europe/Paris");
	private static final DateTimeZone LONDON = DateTimeZone.forID("Europe/London");
	private static final DateTimeZone TOKYO = DateTimeZone.forID("Asia/Tokyo");
	private static final int OFFSET = 1;
	private static final Chronology COPTIC_PARIS = CopticChronology.getInstance(PARIS);
	private static final Chronology COPTIC_LONDON = CopticChronology.getInstance(LONDON);
	private static final Chronology COPTIC_TOKYO = CopticChronology.getInstance(TOKYO);
	private static final Chronology COPTIC_UTC = CopticChronology.getInstanceUTC();
	private static final Chronology ISO_UTC = ISOChronology.getInstanceUTC();
	private static final Chronology BUDDHIST_TOKYO = BuddhistChronology.getInstance(TOKYO);
	private static final Chronology BUDDHIST_UTC = BuddhistChronology.getInstanceUTC();

	private long TEST_TIME_NOW = 10L * DateTimeConstants.MILLIS_PER_HOUR + 20L * DateTimeConstants.MILLIS_PER_MINUTE
			+ 30L * DateTimeConstants.MILLIS_PER_SECOND + 40L;

	private long TEST_TIME2 = 1L * DateTimeConstants.MILLIS_PER_DAY + 5L * DateTimeConstants.MILLIS_PER_HOUR
			+ 6L * DateTimeConstants.MILLIS_PER_MINUTE + 7L * DateTimeConstants.MILLIS_PER_SECOND + 8L;

	public void testGetFieldType() {
		TimeOfDay test = new TimeOfDay(COPTIC_PARIS);
		test.getFieldType(0);
	}

	public void test2() {
		TimeOfDay test = new TimeOfDay(COPTIC_PARIS);
		test.getFieldType(1);
	}

	public void test3() {
		TimeOfDay test = new TimeOfDay(COPTIC_PARIS);
		test.getFieldType(2);
	}

	public void test4() {
		TimeOfDay test = new TimeOfDay(COPTIC_PARIS);
		test.getFieldType(3);
	}

	public void test5() {
		TimeOfDay test = new TimeOfDay(COPTIC_PARIS);
		test.getFieldType(-1);
	}

	public void test6() {
		TimeOfDay test = new TimeOfDay(COPTIC_PARIS);
		test.getFieldType(5);
	}
	
	public static void main(String[] args) {
		TestTimeOfDay_Basics2 t = new TestTimeOfDay_Basics2();
		t.testGetFieldType();
		t.test2();
		t.test3();
		t.test4();
	}

}
