package org.joda.time;

import junit.framework.TestCase;

public class TestYearMonth_Basics11 extends TestCase {

	public void testWithFieldAdded() {
		YearMonth test = new YearMonth(2004, 6);
		YearMonth result = test.withFieldAdded(DurationFieldType.years(), 6);
	}

	public void testWithFieldAdded_nullField_zero() {
		YearMonth test = new YearMonth(2004, 6);
		test.withFieldAdded(null, 0);
	}

	public void testWithFieldAdded_nullField_nonZero() {
		YearMonth test = new YearMonth(2004, 6);
		test.withFieldAdded(null, 6);
	}

	public void testWithFieldAdded_zero() {
		YearMonth test = new YearMonth(2004, 6);
		YearMonth result = test.withFieldAdded(DurationFieldType.years(), 0);
	}

	public void testWithFieldAdded_unknownField() {
		YearMonth test = new YearMonth(2004, 6);
		test.withFieldAdded(DurationFieldType.hours(), 6);
	}
	
	public static void main(String[] args) {
		TestYearMonth_Basics11 t = new TestYearMonth_Basics11();
		t.testWithFieldAdded();
		t.testWithFieldAdded_zero();
	}

}
