package org.joda.time;

import org.joda.time.chrono.BuddhistChronology;
import org.joda.time.chrono.CopticChronology;
import org.joda.time.chrono.ISOChronology;

import junit.framework.TestCase;

public class TestYearMonth_Basics9 extends TestCase {

	private static final DateTimeZone PARIS = DateTimeZone.forID("Europe/Paris");
	private static final DateTimeZone LONDON = DateTimeZone.forID("Europe/London");
	private static final DateTimeZone TOKYO = DateTimeZone.forID("Asia/Tokyo");
	private static final Chronology COPTIC_PARIS = CopticChronology.getInstance(PARIS);
	private static final Chronology COPTIC_LONDON = CopticChronology.getInstance(LONDON);
	private static final Chronology COPTIC_TOKYO = CopticChronology.getInstance(TOKYO);
	private static final Chronology COPTIC_UTC = CopticChronology.getInstanceUTC();
	// private static final Chronology ISO_PARIS =
	// ISOChronology.getInstance(PARIS);
	// private static final Chronology ISO_LONDON =
	// ISOChronology.getInstance(LONDON);
	// private static final Chronology ISO_TOKYO =
	// ISOChronology.getInstance(TOKYO);
	private static final Chronology ISO_UTC = ISOChronology.getInstanceUTC();
	// private static final Chronology BUDDHIST_PARIS =
	// BuddhistChronology.getInstance(PARIS);
	// private static final Chronology BUDDHIST_LONDON =
	// BuddhistChronology.getInstance(LONDON);
	private static final Chronology BUDDHIST_TOKYO = BuddhistChronology.getInstance(TOKYO);
	private static final Chronology BUDDHIST_UTC = BuddhistChronology.getInstanceUTC();

	private long TEST_TIME_NOW = (31L + 28L + 31L + 30L + 31L + 9L - 1L) * DateTimeConstants.MILLIS_PER_DAY;

	public void testWithChronologyRetainFields_Chrono() {
		YearMonth base = new YearMonth(2005, 6, COPTIC_PARIS);
		YearMonth test = base.withChronologyRetainFields(BUDDHIST_TOKYO);
	}

	public void testWithChronologyRetainFields_sameChrono() {
		YearMonth base = new YearMonth(2005, 6, COPTIC_PARIS);
		YearMonth test = base.withChronologyRetainFields(COPTIC_TOKYO);
	}

	public void testWithChronologyRetainFields_nullChrono() {
		YearMonth base = new YearMonth(2005, 6, COPTIC_PARIS);
		YearMonth test = base.withChronologyRetainFields(null);
	}

	public void testWithChronologyRetainFields_invalidInNewChrono() {
		YearMonth base = new YearMonth(2005, 13, COPTIC_UTC);
		base.withChronologyRetainFields(ISO_UTC);
	}
	
	public static void main(String[] args) {
		TestYearMonth_Basics9 t = new TestYearMonth_Basics9();
		t.testWithChronologyRetainFields_Chrono();
		t.testWithChronologyRetainFields_nullChrono();
		t.testWithChronologyRetainFields_sameChrono();
	}

}
